/***********************************************************************        

   File Name: vcr.h

   Description: This file contains definitions that are specific to the 
   VB portion of the VCR Button.

/***********************************************************************/

#include "..\vcrbut\vcrbut.h"

/*
** Toolbox bitmap resource IDs.  These define the bitmaps that are used 
** at design time by App Studio in C++ and Visual Basic.
*/

#define IDBMP_PUSH	 	8000		// Push Button Bitmap
#define IDBMP_PUSHDOWN	8001		// Selected state
#define IDBMP_PUSHMONO	8003		// Offset to Mono Bitmap
#define IDBMP_PUSHEGA	8006		// Offset to EGA bitmap 

/*
** Define who we are.  This will be used also by the About Box.
*/

#define VBX_COMPANYNAME 	   "K-Wave Financial Services\0"
#define VBX_FILEDESCRIPTION	   "VCR Button Custom Control as VBX\0"
#define VBX_INTERNALNAME	   "VCR\0"
#define VBX_LEGALCOPYRIGHT	   "Copyright \251 K-Wave Financial 1985-90\0"
#define VBX_LEGALTRADEMARKS	   "Microsoft\256 is a registered trademark of Microsoft Corporation. Visual Basic\231 is a trademark of Microsoft Corporation. Windows\231 is a trademark of Microsoft Corporation.\0"
#define VBX_ORIGINALFILENAME   "VCR.VBX\0"
#define VBX_PRODUCTNAME 	   "Microsoft\256 Visual C++\231 for Windows\231\0"


/*
** Define a version for the control
*/

#define VBX_VERSION		    2,00,6,01
#define VBX_VERSION_STR 	   "2.00.601\0"

/*
** Defines used by the program.  These are skipped by
** the resource compiler.
*/

#ifndef RC_INVOKED

//---------------------------------------------------------------------------
// Macro for referencing member of structure
//---------------------------------------------------------------------------

#define OFFSETIN(struc, field)	  ((USHORT)&(((struc *)0)->field))


//---------------------------------------------------------------------------
// PUSH control data and structs
//---------------------------------------------------------------------------

typedef struct tagPUSH
{
    WORD bevel_width;
    BOOL value;
} PUSH;

typedef PUSH FAR * LPPUSH;

#define LppushDEREF(hctl)     ((LPPUSH)VBDerefControl(hctl))


/*
** The property list is registered with the control.  When presented by
** either App Studio or the Vsual Basic editor the fields are sorted 
** by name.  Here we create a set of defines that relate to the order 
** that the properties are registered with the editor.  This allows 
** property function to be identified when processing them in the
** control procedure.
*/

#define IPROP_NAME 	  	0
#define IPROP_INDEX	  	1
#define IPROP_PARENT	  	2
#define IPROP_LEFT 	  	3
#define IPROP_TOP		4
#define IPROP_WIDTH	  	5
#define IPROP_HEIGHT	  	6
#define IPROP_ENABLED	7
#define IPROP_VISIBLE	8
#define IPROP_CAPTION	9
#define IPROP_FONTNAME	10
#define IPROP_FONTSIZE	11
#define IPROP_FONTBOLD	12
#define IPROP_FONTITALIC	13
#define IPROP_FONTSTRIKE	14
#define IPROP_FONTUNDER	15
#define IPROP_TABINDEX	16
#define IPROP_TABSTOP	17
#define IPROP_TAG		18
#define IPROP_HWND 	  	19
#define IPROP_BEVEL		20
#define IPROP_VALUE		21

/*
** Also define indexs into the event table
** that is registered with the control.  
** This can be used when processing events
*/

#define EVENT_CLICK		0
#define EVENT_GOTFOCUS   	1
#define EVENT_LOSTFOCUS 	2
#define EVENT_KEYPRESS	4
#define EVENT_KEYDOWN	5
#define EVENT_KEYUP		6

//---------------------------------------------------------------------------
// Control Procedure
//---------------------------------------------------------------------------
LONG FAR PASCAL _export VcrCtlProc(HCTL, HWND, USHORT, USHORT, LONG);


#ifdef NEVER

//---------------------------------------------------------------------------
// Model struct
//---------------------------------------------------------------------------
// Define the control model (using the event and property structures).
//---------------------------------------------------------------------------
MODEL modelPush =
    {
    VB_VERSION, 			// VB version being used
    MODEL_fFocusOk | MODEL_fMnemonic,	// MODEL flags
    (PCTLPROC)VcrCtlProc,	// Control procedure
    CS_VREDRAW | CS_HREDRAW,		// Class style
    WS_VISIBLE,	    // Default Window style
    sizeof(PUSH),			// cbCtlExtra for PUSH structure
    IDBMP_PUSH, 			// Toolbar Palette bitmap ID
    "Vcr",					// Default control name
    "VbxButton",			// Visual Basic class name
    "VCRButton",			// Parent class name
    proplistPush,			// Properties list
    eventlistPush,			// Events list
    IPROP_PUSH_CAPTION, 	// Default property
    EVENT_PUSH_DRAGDROP,    // Default event
    IPROP_PUSH_CAPTION		// Property representing value of ctl
    };

LPMODEL modellistPush[] =
    {
    &modelPush,
    NULL
    };

MODELINFO modelinfoPush =
    {
    VB_VERSION, 			// VB version being used
    modellistPush			// MODEL list
    };
#endif

#endif // RC_INVOKED
